
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Yellow
#property indicator_color2 Aqua
#property indicator_color3 Red

//---- input parameters
extern int        MAType=MODE_EMA;
extern double    MAPeriod=7;
extern int        TDEma=3;
 double    Grad=1;

 static double bbup,bbdn,bbm,trnd,rslt;
 static double pbbup,pbbdn,pbbm;

//---- buffers
double upbuf[];
double dnbuf[];
double Emabuf[];
double Demabuf[];
double Temabuf[];
double bdif[];
//---- Globals
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(3,DRAW_NONE);
   SetIndexBuffer(0,Temabuf);
   SetIndexBuffer(1,upbuf);
   SetIndexBuffer(2,dnbuf);
   SetIndexBuffer(3,bdif);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
   double bb;
   int i,limit;
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;
   limit=100;
   for(i = limit; i >=0 ; i--){
         bb=iCustom(Symbol(),0,"Bands",13,0,1,0,0,0,i);
         bdif[i]=(High[i]-bb)*10000;
   }   
   for(i = limit; i >=0 ; i--){
//       Temabuf[i] = iMAOnArray(bdif, 0, MAPeriod, 0, MAType, i);
       Temabuf[i] = iMAOnArray(bdif, 100, MAPeriod, 0, MAType, i);
   }

   for(i = limit; i >=0 ; i--){
        upbuf[i] = EMPTY_VALUE;
        dnbuf[i] = EMPTY_VALUE;
        if((Temabuf[i]-Temabuf[i+1])>Grad*Point){
           upbuf[i] = Temabuf[i];
        }
        if((Temabuf[i]-Temabuf[i+1])<-Grad*Point){
           dnbuf[i] = Temabuf[i];
        }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+